class Distribution;

extern unsigned int grouped_data;

extern unsigned int ngroup;


typedef long double (*AdequacyStat)(unsigned int,const long double *,const Distribution &);


class Distribution{
public:
  virtual unsigned int numpars() const=0;
  virtual unsigned int numvalidpars() const=0;
  virtual const char *const*validparnames() const=0;
  virtual long double dist(long double x) const=0;
  virtual long double survive(long double x) const=0;
  virtual long double quant(long double p) const=0;
  virtual long double random() const=0;  
  virtual void setfixed(unsigned int i,long double val)=0;
  virtual void unfix(unsigned int i)=0;
  virtual void setmain(unsigned int i,long double at)=0;
  virtual long double parval() const=0;
  virtual long double parval(unsigned int i,long double at) const=0;
  virtual long double transform_data(long double data) const=0;
  virtual long double untransform_data(long double data) const=0;
  virtual long double get_critval(long double size,AdequacyStat stat) const=0;
  virtual long double adjustADstat(unsigned int samplesize) const=0;
  //Use transform data on the original data, then untransform data
  //where necessary. This saves time with the bootstrap for log-normal
  //for example.
  virtual unsigned int numestpars() const=0;

  virtual Distribution* copy() const=0;
  virtual void estimate_data(unsigned int n,const long double *data)=0;
  virtual void estimate_data(unsigned int n,const long double *data,const unsigned int *smp)=0;
  virtual void estimate_data(unsigned int c,const unsigned int *counts,const long double *cutoffs)=0;//for grouped data
  virtual const char *distname() const=0;
  virtual void print() const=0;
  virtual ~Distribution(){};
};

void set_up_distributions();

Distribution &read_distribution(int argc,char *argv[],unsigned int &start);


class Data{
public:
  unsigned int n;
  long double *data;
};

class FreqTable{
public:
  unsigned int n;
  long double *data;
  unsigned int *count;
};

class GroupedData{
public:
  unsigned int n;
  long double *data;
  unsigned int *count;
};
